#pragma once
namespace DXFW
{
/// <summary>J̒ǐՕ</summary>
enum class ChaseType
{
	NormalChase,
	Smooth,
	XToY,
	YToX,
	Warp
};
	
///	<summary>2Dp̃JNX</summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Camera
{
private:
	double x;//݂̈ʒu
	double y;
	double zoom;

	double forcusX;//ړڕW
	double forcusY;
	double forcusZ;

	double speed;//ړx
	double speedZ;

	double centerX;//œ_ʒu
	double centerY;

	static Camera* cameraNow;

	ChaseType chaseType;
public:
	///<summary>J̍쐬</summary>
	///WƊg嗦w肵ăJ
	Camera(double WX , double WY , double g嗦):
		x(WX),
		y(WY),
		zoom(g嗦),
		forcusX(WX),
		forcusY(WY),
		forcusZ(g嗦),
		speed(1),
		speedZ(1),
		centerX(WX),
		centerY(WY),
		chaseType(ChaseType::Warp)
	{};
			
	///<summary>o^̃J擾</summary>
	///ݗLȃJ擾
	static Camera* Now()
	{
		return cameraNow;
	}
			
	///<summary>Jo^</summary>
	///ݗLȃJo^
	static void SetNow(Camera* ANeBuJ)
	{
		cameraNow = ANeBuJ;
	}
			
	///<summary>J̏œ_ݒ</summary>
	void SetCenter(double XW , double YW)
	{
		this->centerX = XW;
		this->centerY = YW;
	}
			
	///<summary>œ_XW擾</summary>
	double GetCenterX()
	{
		return this->centerX;
	}
		
	/// <summary>ړڕWYW擾</summary>
	double GetCenterY()
	{
		return this->centerY;
	}

	///<summary>ʒuƔ{ݒ</summary>
	void Set(double XW , double YW ,double g嗦)
	{
		this->x = XW;
		this->y = YW;
		this->zoom = g嗦;
	}
			
	///<summary>ړڕWW𑊑Έړ</summary>
	void MoveForcus(double XW ,double YW)
	{
		this->forcusX += XW;
		this->forcusY += YW;
	}
			
	///<summary>ړڕWWݒ</summary>
	void SetForcus(double XW , double YW)
	{
		this->forcusX = XW;
		this->forcusY = YW;
	}
			
	///<summary>gڕWZbg</summary>
	void SetZoomForcus(double g嗦)
	{
		this->forcusZ = g嗦;
	}
			
	///<summary>ǐՑxݒ</summary>
	void SetSpeed(double ǐՑx)
	{
		this->speed = ǐՑx;
	}
		
	///<summary>g剞xݒ</summary>
	void SetZoomSpeed(double g呬x)
	{
		this->speedZ = g呬x;
	}
			
	///<summary>g嗦擾</summary>
	double GetZoom()
	{
		return this->zoom;
	}
			
	///<summary>ǐՕ@ݒ</summary>
	void SetChaseType(ChaseType ǐՃ^Cv)
	{
		chaseType = ǐՃ^Cv;
	}

	///<summary>Jʒu̍XV</summary>
	///ǐՕ@ǐՑxɉāAJʒuXV
	void Update()
	{
		x = x/2 + forcusX/2;
		y = y/2 + forcusY/2;
		zoom = zoom/2 + forcusZ/2;
	}
			
	///<summary>XWϊ</summary>
	///J̈ʒuƊg嗦ɉāAWϊĕԂ
	double TranX(double XWϊO)
	{
		return centerX + ( XWϊO - this->x ) * zoom;
	}
			
	/// <summary>YWϊ</summary>
	///J̈ʒuƊg嗦ɉāAWϊĕԂ
	double TranY(double YWϊO)
	{
		return centerY + ( YWϊO - this->y ) * zoom;
	}
};
}
