#pragma once
#include<DxLib.h>
#include<Color.h>
#include<vector>
#include<string>
#include<Image.h>

namespace DXFW
{
///	<summary>\[Xǂݍ܂ɕ`</summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Drawing
{
private:
	Drawing();
	~Drawing();		
public:
			
	///<summary>`</summary>
	///n_ƏI_Ԓ`
	static bool Line( int n_X , int n_Y , int I_X , int I_Y , int F , int )
	{
		return !DxLib::DrawLine( n_X , n_Y , I_X , I_Y , F ,  );
	}

	///<summary>``</summary>
	///WaƍWbΊp̒_Ƃ``
	static bool Rect( int WaX , int WaY , int WbX , int WbY , int F , bool hԂtO )
	{
		return !DxLib::DrawBox( WaX , WaY , WbX , WbY , F , hԂtO );
	}
	static bool RectMask( int x1 , int y1 , int x2 , int y2 , ZMaskType type, bool isFill )
	{
		return !DxLib::DrawBoxToZBuffer( x1 , y1 , x2 , y2 , isFill , (int)type );
	}

	///<summary>~`</summary>
	///SƔaw肵ĉ~`
	static bool Circle( int SX , int SY , int a , int F , bool hԂtO )
	{
		return !DxLib::DrawCircle( SX , SY , a , F , hԂtO );
	}
	static bool CircleZMask( int SX , int SY , int a , int F , bool hԂtO )
	{
		return !DxLib::DrawCircleToZBuffer( SX , SY , a , hԂtO , DX_ZWRITE_MASK );			
	}

	///<summary>ȉ~`</summary>
	///SƊOڂlp`̑傫w肵đȉ~`
	static bool Oval( int SX , int SY , int  , int  , int F , bool hԂtO )
	{
		return !DxLib::DrawOval( SX , SY ,  ,  , F , hԂtO );
	}

	///<summary>Op``</summary>
	///_Rw肵āAOp``
	static bool Triangle( int _aX , int _aY , int _bX , int _bY , int _cX , int _cY , int F , bool hԂtO )
	{
		return !DxLib::DrawTriangle( _aX , _aY , _bX , _bY , _cX , _cY , F , hԂtO);
	}

	///<summary>_`</summary>
	///Ww肵1sNZ̓_`
	static bool Pixel( int WX , int WY , int F )
	{
		return !DxLib::DrawPixel( WX , WY , F );
	}

	///<summary>wW̐F擾</summary>
	///Ww肵āAXN[̐F擾
	static int GetPixel( int WX , int WY )
	{
		return DxLib::GetPixel( WX , WY );
	}

	///<summary>摜t@C`</summary>
	///摜ꎞIɃɓǂݍŕ`
	///̏͏d̂ŁAʏImageNX𗘗p
	static bool ImageFile( int WX , int WY , const char *t@C , bool ߃tO = true )
	{
		return !DxLib::LoadGraphScreen( WX , WY , t@C , ߃tO);
	}

	///<summary>tŕ`</summary>
	///t`AtHg̓ftHgŃSVbN
	static void String( int XW , int YW , int F , const char * , ... )
	{
		char bufstr[1024];
		va_list args;
		va_start(args,);
		vsprintf_s( bufstr , 1024 ,  , args );
		va_end(args);

		char *pstr,*stro;
		stro = strtok_s( bufstr , "\n" , &pstr );

		while(stro != NULL)
		{
			DxLib::DrawString( XW , YW , stro , F );
			stro = strtok_s( NULL , "\n" , &pstr );
			YW += 20;
		}
	}

	static void StringZMask( int XW , int YW  , ZMaskType Z}XN , const char * , ... )
	{
		char bufstr[1024];
		va_list args;
		va_start(args,);
		vsprintf_s( bufstr , 1024 ,  , args );
		va_end(args);

		char *pstr,*stro;
		stro = strtok_s( bufstr , "\n" , &pstr );

		while(stro != NULL)
		{
			DxLib::DrawStringToZBuffer( XW , YW , stro , (int)Z}XN);
			stro = strtok_s( NULL , "\n" , &pstr );
			YW += 20;
		}
	}
};
}