#pragma once
#include<DxLib/DxLib.h>
#include<Window.h>
#include<Screen.h>
#include<Input.h>

const double PAI = 3.1415926535897931;
const double DEG = PAI / 180;

namespace DXFW
{
///	<summary>
///	NX
///	</summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Dx
{
private:
	Dx();
	~Dx();
public:

	///<summary>Cȕ</summary>
	///CuB
	///ɎsꍇA\tgIɏIB
	///ꕔ̐ݒ֐͏OɌĂяoKvB
	static void Initialise( char* EBhE , int  , int  , int F[x = 32 )
	{
		Window::SetMainText( EBhE );
		Window::SetGraphMode(  ,  , F[x );

		if( !Window::Single().isFullScreen )
		{
			DxLib::ChangeWindowMode( true );
		}

		if( DxLib::DxLib_Init() == -1 ) exit(1);

		DxLib::SetDrawScreen( DX_SCREEN_BACK ); 
	}
			
	///<summary>CȕI</summary>
	///Cu̎gpIB
	///̊֐gp͑₩ɃvOIĉB
	static bool End()
	{
		return !DxLib::DxLib_End();
	}

	static bool Update()
	{
		Screen::Flip();
		Screen::Clear();
		Input::Update();
		return Dx::ProcessMessage();
	}

	///<summary>Windows̃bZ[W</summary>
	///Windows̃bZ[W[vsB
	///ڈƂ1/60bɈxÅ֐ĂяoKvB
	///falseԂꍇA₩ɃvOIĉB
	static bool ProcessMessage()
	{
		return !DxLib::ProcessMessage();
	}
			
	///<summary>Oo̗͂Lݒ</summary>
	///DXCũfobO񃍃OEt@CwApp.logxo͐ݒ肷B
	///̊֐́AInitialiseOɌĂяoKvB
	static bool SetOutputLog( bool isOut)
	{
		return !DxLib::SetOutApplicationLogValidFlag( isOut );
	}
			
	///<summary>rfIRAMgpݒ</summary>
	///̊֐́AInitialiseOɌĂяoKvB
	static bool SetMemToVram( bool isVram)
	{
		return !SetScreenMemToVramFlag( isVram );
	}

	///<summary>ANeBu𑱍s邩ݒ</summary>
	///ʏ͔ANeBu͏~܂B
	static bool SetAlwaysRun( bool isAlways )
	{
		return !DxLib::SetAlwaysRunFlag( isAlways );
	}
};
}







