#pragma once

namespace DXFW
{
class Speed
{
protected:
	double speed;
public:
	Speed(double x):
			speed(x)
	{}

	virtual double Get() const
	{
		return speed; 
	};

	double Ease()
	{
		Update();
		return Get();
	}

	virtual void Update() = 0;

	virtual void Multi(double {)
	{
		speed *= {;
	}

	virtual void Add(double Zl)
	{
		speed += Zl;
	}

	operator double()
	{
		return Ease();
	}
};
}