#pragma once
#include "Image.h"

namespace DXFW
{
/// <summary>R}̈ړ</summary>
/// ڍא
enum class NextFrame
{
	Normal  = -10000,///̃R}ɐi
	ToFront ,///R}̐iތvXɂĂi
	ToBack  ,///R}̐iތ}CiXɂĂi
	End     ,///̃R}ŃAj[V~
};

enum class AnimeType
{
	Normal,///Ō܂ōĐƂ܂ŏĐ
	Reverse,///Ō܂ōĐƁAĐ𔽓]
	End///ŏIt[ōĐ~
};

///	<summary>
/// ܂Ƃ߂ImageR}Aj[VƂĈNX
///	</summary>
///	<example>
///	[TvR[h:]<br/>
/// Tv<br/>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<br/>
///	{<br/>
///		if( !Dx::Initialise() ) return -1;<br/>
///		Dx::End();<br/>
///		return 0;<br/>
/// }<br/>
/// </code>	
/// </example>
class Anime : public ImagePack
{
private:
	std::vector<unsigned int> times;//R}̃t[
	std::vector<int> nexts;//eR}̎t[
public:
	///<summary>R}̊Ǘ</summary>
	///ڍא<br/>
	class Counter
	{
	private:
		Anime& anime;//ΉAj
		int direct;//is
		int frameNumber;//݂̃R}
		double timer;//oߎ
	public:
		
		///<summary>JE^쐬</summary>
		Counter(Anime& eAj):
			anime(eAj),
			direct(1),
			frameNumber(0),
			timer(0)
		{}

		///<summary>JE^̍XV</summary>
		bool UpDate( double o߃t[)
		{
			timer += o߃t[;

			double totalTime = 0;

			if( timer > anime.times[frameNumber] )
			{
				timer -= anime.times[frameNumber];
				switch ( anime.nexts[frameNumber] )
				{
					case (int)NextFrame::Normal:
						frameNumber += direct;
					break;
					case (int)NextFrame::ToFront:
						direct = 1;
						frameNumber += direct;
					break;
					case (int)NextFrame::ToBack:
						direct = -1;
						frameNumber += direct;
					break;
					case (int)NextFrame::End:
						return false;
					break;
					default:
						frameNumber = anime.nexts[frameNumber];
					break;
				}

				if( (unsigned int)frameNumber >= anime.images.size() ) frameNumber = 0;
				if( frameNumber < 0									  )	frameNumber = anime.images.size()-1;
			}

			return true;
		}
		
		///<summary>݂̃R}ԍ擾</summary>
		int GetFrame()
		{
			return frameNumber;
		}
		
		///<summary>R}̈ʒuݒ</summary>
		void SetFrame(int R} )
		{
			this->frameNumber = R};
			timer = 0;
		}
	};
		
	Anime(){}

	/// <summary>摜t@C𕪊Ǎ</summary>
	/// 摜t@C𕪊ă֓ǂݍށB<br/>
	/// eR}̃t[͏1ɂȂ܂B
	Anime( const char *t@C , int R} ,int R}艡,int R}c,int R} ,int R} ):
		ImagePack( t@C , R} ,R}艡 , R}c , R} , R})
	{
		for( unsigned int i=0; i<times.size() ; i++ )
		{
			times[i] = 1;
			nexts[i] = (int)NextFrame::Normal;
		}
	}
	
	///<summary>P̉摜𕪊ēǂݍ</summary>
	///eR}̃t[Ԃ͏1ɂȂ܂B
	bool Load(const char *t@C , int R},int R}艡, int R}c ,int R},int R}c )
	{
		std::vector<int> buf(R});

		if( DxLib::LoadDivGraph(t@C,R},R}艡,R}c,R},R}c, &buf.front() ) == 0 )
		{
			for(int i=0;i<R};i++)
			{
				this->Add( new Image(buf[i]) );
			}
		}			

		return true;
	}
			
	/// <summary>Aԃt@Cꊇēǂݍ</summary>
	bool Load(const char* t@C , const char *gq , int R} )
	{
		for(int i=0 ; i<R} ; i++)
		{ 
			char fileBuf[8];
			sprintf_s( fileBuf , 8 , "%03d." , i );
			std::string fileName = t@C;
			fileName += fileBuf;
			fileName += gq;

			this->Add( new Image( fileName.c_str() ) );
		}
		return true;
	}

	/// <summary>C[Wǉ</summary>
	/// ɐVC[WǉB
	void Add(Image *ǉC[W)
	{
		ImagePack::Add( ǉC[W );
		times.push_back( 1 );
		nexts.push_back( (int)NextFrame::Normal);
	}
	void Add(const char *t@C)
	{
		Add( new Image( t@C ) );
	}

	/// <summary>C[WJ</summary>
	/// SẴC[WJ
	void Release()
	{
		ImagePack::Release();

		times.clear();
		nexts.clear();
	}

	///<summary>eR}̃t[ݒ</summary>
	///擪R}t[ĐԂݒ肷
	void SetFrameTime( int* t[ )
	{
		for(unsigned int i=0 ; i< times.size() ; ++i )
		{
			times[i] = t[[i];
		}
	}

	///<summary>eR}̃t[ݒ</summary>
	///ŏIR}̎t[w肷
	void SetType( AnimeType Đ@ )
	{
		switch(Đ@)
		{
			case AnimeType::Normal:
				nexts[nexts.size()-1] =(int)NextFrame::Normal;
			break;
			case AnimeType::Reverse:
				nexts[0] =(int)NextFrame::ToFront;
				nexts[nexts.size()-1] =(int)NextFrame::ToBack;
			break;
			case AnimeType::End:
				nexts[nexts.size()-1] =(int)NextFrame::End;
			break;
		}
	}
	
	///<summary>eR}̃t[ݒ</summary>
	///w肵R}̎t[ݒ肷
	void SetType( int R}ԍ , int t[ )
	{
		nexts[R}ԍ] = t[;
	}
	void SetType( int R}ԍ , NextFrame t[ )
	{
		nexts[R}ԍ] = (int)t[;
	}

	/// <summary>vt[ԂԂ</summary>
	/// SẴt[ĐԂ̘aԂ
	int GetAnimeTime() const
	{
		int totalTime = 0;

		for( auto it : times )
		{
			totalTime += it;
		}

		return totalTime;
	}

	Image* operator[](int index)
	{
		return images[index];
	}
};
}