#pragma once
#include <DxLib.h>

namespace DXFW
{
///	<summary>̒~NX</summary>
///	<example>
///	[TvR[h:]<BR>
/// Tv<BR>
///	<code>
///	int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )<BR>
///	{<BR>
///		if( !Dx::Initialise() ) return -1;<BR>
///		Dx::End();<BR>
///		return 0;<BR>
/// }<BR>
/// </code>	
/// </example>
class Wait
{
private:
	Wait();
	~Wait();
public:
	
	///<summary>w~bs~</summary>
	static bool Timer(int waitTime)
	{
		return !DxLib::WaitTimer(waitTime);
	}
	
	/// <summary>M҂</summary>
	static bool VSync(int syncNum)
	{
		return !DxLib::WaitVSync(syncNum);
	}
	
	/// <summary>L[͂҂</summary>
	static bool PushKey()
	{
		return !DxLib::WaitKey();
	}
};
}
